#pragma once

#include <GL/glew.h>

#include <vcg/space/point3.h>
#include <stdlib.h>
#include <iostream>

#include "Lens.h"

using namespace vcg;

//settings one flare
void Flare::SetFlare(GLuint Texture, float Location, float Scaling, float Col[3], float ColorScale){
	Tex = Texture;
	Loc = Location;
	Scale = Scaling;
	Color[0] = Col[0] * ColorScale;
	Color[1] = Col[1] * ColorScale;
	Color[2] = Col[2] * ColorScale;
}


Flares::Flares(void){ 
	TOT_FLARES = 1;
	F = new Flare[TOT_FLARES];
	G_Scale = 1.5;
}
Flares::Flares(int NumFlares){ 
	TOT_FLARES = NumFlares;
	F = new Flare[TOT_FLARES];
	G_Scale = 1.5;
}
void Flares::DoFlares(vcg::Point3f from, vcg::Point3f at, vcg::Point3f light_pos, float near_clip){
	//direzione di vista
	vcg::Point3f view_dir = at-from; 
	view_dir=view_dir.Normalize();

	//centro della finestra
	vcg::Point3f center = from + view_dir * near_clip;
	
	//direzione della luce: sole <--> pov
	vcg::Point3f light_dir = light_pos - from; 
	light_dir=light_dir.Normalize();
	light_pos = from + light_dir * ((float) near_clip / (float)(light_dir * view_dir) );
	//printf("dot %f\n",light_dir*view_dir);
	
	//asse lungo cui mettere le texture
	vcg::Point3f axis = light_pos - center;
	vcg::Point3f dx = axis;
	dx=dx.Normalize();
	vcg::Point3f dy = dx ^ view_dir;

	glDisable(GL_DEPTH_TEST);
	glEnable(GL_BLEND);
	glBlendFunc(GL_ONE, GL_ONE);

	glEnable (GL_TEXTURE_2D);
	glTexEnvf( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE );

	for(int i=0; i<TOT_FLARES; i++){
		vcg::Point3f sx = dx * F[i].Scale * G_Scale;
		vcg::Point3f sy = dy * F[i].Scale * G_Scale;

		glColor3fv(F[i].Color);
		glBindTexture(GL_TEXTURE_2D, F[i].Tex);

		vcg::Point3f position = center + axis * F[i].Loc; 
		vcg::Point3f tmp;

		glBegin(GL_QUADS);
			glTexCoord2f(0.0, 0.0);
			tmp = position + sx + sy;
			glVertex3f(tmp[0],tmp[1],tmp[2]);

			glTexCoord2f(1.0, 0.0);
			tmp = position - sx + sy;
			glVertex3f(tmp[0],tmp[1],tmp[2]);

			glTexCoord2f(1.0, 1.0);
			tmp = position - sx - sy;
			glVertex3f(tmp[0],tmp[1],tmp[2]);

			glTexCoord2f(0.0, 1.0);
			tmp = position + sx - sy;
			glVertex3f(tmp[0],tmp[1],tmp[2]);
		glEnd();
	}
	glEnable(GL_DEPTH_TEST);
	glDisable(GL_BLEND);
	glDisable (GL_TEXTURE_2D);
}